import "core-js/modules/es6.object.set-prototype-of";

var __extends = this && this.__extends || function () {
  var _extendStatics = function extendStatics(d, b) {
    _extendStatics = Object.setPrototypeOf || {
      __proto__: []
    } instanceof Array && function (d, b) {
      d.__proto__ = b;
    } || function (d, b) {
      for (var p in b) {
        if (b.hasOwnProperty(p)) d[p] = b[p];
      }
    };

    return _extendStatics(d, b);
  };

  return function (d, b) {
    _extendStatics(d, b);

    function __() {
      this.constructor = d;
    }

    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
}();

import * as React from 'react';
import './tagFilter.css';
var colors = ['#ed5858', '#f28d49', '#f5d540', '#38ba72', '#55c6c6', '#41b0d9', '#5b99ee'];

var Filter =
/** @class */
function (_super) {
  __extends(Filter, _super);

  function Filter(p) {
    var _this = _super.call(this, p) || this;

    _this.before = 0;

    _this.handleEnter = function (k) {
      _this.setState({
        hoverIndex: k
      });
    };

    _this.handleLeave = function (k) {
      _this.setState({
        hoverIndex: _this.state.selectedIndex
      });
    };

    _this.handleClick = function (k) {
      var handleClick = _this.props.handleClick;
      _this.before = k;

      _this.setState({
        selectedIndex: k
      });

      handleClick(k);
    };

    _this.getColor = function (selected, k) {
      if (k == 0 && selected) {
        return '#3f9cee';
      } else {
        return selected ? colors[k % 7] : '#e7eef3';
      }
    };

    _this.state = {
      selectedIndex: p.selectexIndex,
      hoverIndex: p.selectexIndex
    };
    _this.before = p.selectexIndex;
    return _this;
  }

  Filter.prototype.render = function () {
    var _this = this;

    var tagData = this.props.tagData;
    var _a = this.state,
        selectedIndex = _a.selectedIndex,
        hoverIndex = _a.hoverIndex;
    return React.createElement("div", {
      className: 'tags-wrap'
    }, tagData.map(function (text, k) {
      var selected = selectedIndex == k;
      var hovered = hoverIndex == k;
      return React.createElement("span", {
        className: 'a-tag',
        onClick: function onClick() {
          _this.handleClick(k);
        },
        onMouseEnter: function onMouseEnter() {
          _this.handleEnter(k);
        },
        onMouseLeave: function onMouseLeave() {
          _this.handleLeave(k);
        },
        style: {
          backgroundColor: _this.getColor(selected || hovered, k),
          color: selected || hovered ? '#fff' : '#8f9ca6'
        },
        key: "a-tag" + k
      }, text);
    }));
  };

  return Filter;
}(React.Component);

export default Filter;