import "core-js/modules/es6.object.assign";
import "core-js/modules/es6.object.set-prototype-of";

var __extends = this && this.__extends || function () {
  var _extendStatics = function extendStatics(d, b) {
    _extendStatics = Object.setPrototypeOf || {
      __proto__: []
    } instanceof Array && function (d, b) {
      d.__proto__ = b;
    } || function (d, b) {
      for (var p in b) {
        if (b.hasOwnProperty(p)) d[p] = b[p];
      }
    };

    return _extendStatics(d, b);
  };

  return function (d, b) {
    _extendStatics(d, b);

    function __() {
      this.constructor = d;
    }

    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
}();

var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

import * as React from 'react';
import Reward from './Reward'; //打赏

import Rewarded from './Rewarded'; //获赏公告

import Header from '../../../../components/common/componentHeader';
import './common.css';
import ScrollWrap from '../../../../components/common/scrollWrap';
import { getUserInfo, getBSGlobal, goReward } from '../../../../helper';
import sizeProvider from '../../../../components/common/sizeProVider';

function RightCom() {
  //https://www.italent.cn/107109868/ITalentHome#
  //widget%2Fitalent%3FiTalentFrame%3D
  //http://www.italent.link/u/201038245/Home#widget%2Fitalent%3FiTalentNavId%3D12294%26iTalentFrameType%3Diframe%26iTalentFrame%3Dhttp%253A%252F%252Fwww.italent.link%252F201038245%252FUIBuilder%253Ftenant_id%2523%252F%26user_id%3D201038245%26app_id%3D100%26time_stamp%3D1528683607%26sign%3D6ecae58ab9172949995174f0e736d86e%26sign_type%3D1%23%2FCompanyContacts
  //https%253A%252F%252Fwww.italent.cn%252F107109868%252FUIBuilder%2523%252FPersonalSettings%26
  var uid = getUserInfo().Id;
  var ifreamUrl = location.protocol + "//" + getBSGlobal('isvDomain') + "/" + uid + "/UIBuilder#/BountySetting";
  var url = "//" + getBSGlobal('isvDomain') + "/" + uid + "/ITalentHome#" + encodeURIComponent("widget/italent?iTalentFrame=" + encodeURIComponent(ifreamUrl) + "&");
  return React.createElement("span", {
    className: 'right-component',
    onClick: function onClick() {
      window.open(url);
    }
  }, "\u67E5\u770B\u6211\u7684\u6253\u8D4F");
}

var RewardedWrap =
/** @class */
function (_super) {
  __extends(RewardedWrap, _super);

  function RewardedWrap() {
    var _this = _super !== null && _super.apply(this, arguments) || this;

    _this.turn = function () {
      _this.props.flipTrigger();
    };

    return _this;
  }

  RewardedWrap.prototype.render = function () {
    return React.createElement("div", {
      className: 'reward-wrap'
    }, React.createElement(Header, {
      icon: 'font-reward',
      title: "\u83B7\u8D4F\u516C\u544A\u677F",
      color: '#ee484f',
      rightComponent: RightCom,
      outWidth: '50px'
    }), React.createElement("div", {
      className: 'inner-wrap-rewarded'
    }, React.createElement(Rewarded, {
      goReward: goReward
    })), React.createElement("span", {
      className: 'icon-bottom font-flip',
      onClick: this.turn
    }));
  };

  return RewardedWrap;
}(React.Component);

var RewardWrap =
/** @class */
function (_super) {
  __extends(RewardWrap, _super);

  function RewardWrap() {
    var _this = _super !== null && _super.apply(this, arguments) || this;

    _this.turn = function () {
      _this.props.flipTrigger(_this.props.visiable);
    };

    return _this;
  }

  RewardWrap.prototype.render = function () {
    var _a = this.props,
        pHeight = _a.pHeight,
        pWidth = _a.pWidth;
    return React.createElement("div", {
      className: pWidth < 301 ? 'reward-wrap reward-wrap-little' : 'reward-wrap'
    }, React.createElement(Header, {
      icon: 'font-reward',
      title: "\u6253\u8D4F",
      color: '#ee484f',
      rightComponent: RightCom,
      outWidth: '50px'
    }), React.createElement(ScrollWrap, {
      height: 'calc(100% - 57px)'
    }, React.createElement("div", {
      className: 'inner'
    }, React.createElement("div", {
      className: 'inner-wrap',
      style: {
        minHeight: pHeight - 80 + 'px'
      }
    }, React.createElement(Reward, __assign({}, this.props))))), React.createElement("span", {
      className: 'icon-bottom font-flip',
      onClick: this.turn
    }));
  };

  RewardWrap.displayTitle = '打赏获赏';
  RewardWrap.backSide = RewardedWrap;
  return RewardWrap;
}(React.Component);

export default sizeProvider(RewardWrap);